<?php

namespace Concrete\Package\Chatwee\Controller\SinglePage\Dashboard;

use \Concrete\Core\Page\Controller\DashboardPageController;
use \Concrete\Core\User\Group\GroupList;
use Package;
use Request;

defined('C5_EXECUTE') or die("Access Denied.");

class Chatwee extends DashboardPageController
{
    public function view()
    {
      	$this->pkg = Package::getByHandle('chatwee');

	    $chatweeCode = $this->pkg->getConfig()->get('concrete.chatwee.chatwee_code');
        $chatweeSsoEnable = $this->pkg->getConfig()->get("concrete.chatwee.chatwee_sso_enable");
        $chatweeSsoChatId = $this->pkg->getConfig()->get('concrete.chatwee.chatwee_sso_chat_id');
        $chatweeSsoApiKey = $this->pkg->getConfig()->get('concrete.chatwee.chatwee_sso_api_key');
      	$chatweeSsoAdminGroups = $this->pkg->getConfig()->get("concrete.chatwee.chatwee_sso_admin_groups");

		$this->set('chatweeCode', $chatweeCode);
        $this->set("chatweeSsoEnable", $chatweeSsoEnable);
        $this->set('chatweeSsoChatId', $chatweeSsoChatId);
        $this->set('chatweeSsoApiKey', $chatweeSsoApiKey);
        $this->set("chatweeSsoAdminGroups", $chatweeSsoAdminGroups);

		$list = new GroupList();
		$list->includeAllGroups();
		$groups = $list->get();
		$groups = array_filter($groups, function($group)
		{
			return $group->getGroupID() !== "1";
		});
		$this->set('groups', $groups);
    }

    public function updated()
    {
        $this->set('message', t("Settings saved."));
        $this->view();
    }

    public function submit()
    {
      	$this->pkg = Package::getByHandle('chatwee');

      	$postData = Request::post();

		if (isSet($postData['CHATWEE_CODE']) && strlen($postData['CHATWEE_CODE']))
		{
			$chatweeCode = htmlentities($postData['CHATWEE_CODE'], ENT_QUOTES);
			$this->pkg->getConfig()->save('concrete.chatwee.chatwee_code', $chatweeCode);
		}

		if (isSet($postData['CHATWEE_SSO_ENABLE']) && strlen($postData['CHATWEE_SSO_ENABLE']))
		{
			$chatweeSsoEnable = $postData['CHATWEE_SSO_ENABLE'];
			$this->pkg->getConfig()->save('concrete.chatwee.chatwee_sso_enable', $chatweeSsoEnable);
		}
		else
		{
			$chatweeSsoEnable = 0;
			$this->pkg->getConfig()->save('concrete.chatwee.chatwee_sso_enable', $chatweeSsoEnable);
		}

		if (isSet($postData['CHATWEE_SSO_CHAT_ID']) && strlen($postData['CHATWEE_SSO_CHAT_ID']))
		{
			$chatweeSsoChatId = $postData['CHATWEE_SSO_CHAT_ID'];
			$this->pkg->getConfig()->save('concrete.chatwee.chatwee_sso_chat_id', $chatweeSsoChatId);
		}

		if (isSet($postData['CHATWEE_SSO_API_KEY']) && strlen($postData['CHATWEE_SSO_API_KEY']))
		{
			$chatweeSsoApiKey = $postData['CHATWEE_SSO_API_KEY'];
			$this->pkg->getConfig()->save('concrete.chatwee.chatwee_sso_api_key', $chatweeSsoApiKey);
        }

        if (isSet($postData['CHATWEE_SSO_ADMIN_GROUPS']))
        {
			$chatweeSsoAdminGroups = $postData['CHATWEE_SSO_ADMIN_GROUPS'];
			$this->pkg->getConfig()->save('concrete.chatwee.chatwee_sso_admin_groups', $chatweeSsoAdminGroups);
        }
        else
        {
        	$chatweeSsoAdminGroups = array();
			$this->pkg->getConfig()->save('concrete.chatwee.chatwee_sso_admin_groups', $chatweeSsoAdminGroups);
        }

		$this->redirect('/dashboard/chatwee', 'updated');
    }
}