<?php

namespace Chatwee\Sso;

use Concrete\Core\Support\Facade\Application;
use Chatwee\Sso\SsoConfiguration;
use Exception;
use Core;
use Request;

defined('C5_EXECUTE') or die("Access Denied.");

class SsoSession
{
	private static function getCookieKey()
	{
		if(SsoConfiguration::isConfigurationSet() === false)
		{
			throw new Exception("Chatwee error: the client credentials are not set");
		}
		return "chatwee-SID-" . SsoConfiguration::getChatId();
	}

    public static function getSessionId()
    {
    	$cookieKey = self::getCookieKey();

		$app = Application::getFacadeApplication();

		$cookie = $app->make('cookie');

		$cookieValue = $cookie->get($cookieKey);

    	return isSet($cookieValue) ? $cookieValue : null;
    }

    public static function setSessionId($sessionId)
    {
    	$cookieDomain = self::getCookieDomain();

    	$app = Application::getFacadeApplication();

    	$cookiePath = $cookieDomain === null ? $app['app_relative_path'] . "/" : "/";

		$app = Application::getFacadeApplication();

		$cookie = $app->make('cookie');

		$cookie->set(self::getCookieKey(), $sessionId, time() + 2592000, $cookiePath, $cookieDomain, false, false);
    }

    public static function clearSessionId()
    {
		$cookieDomain = self::getCookieDomain();

    	$app = Application::getFacadeApplication();

    	$cookiePath = $cookieDomain === null ? $app['app_relative_path'] . "/" : "/";

		$app = Application::getFacadeApplication();

		$cookie = $app->make('cookie');

		$cookie->set(self::getCookieKey(), $sessionId, time() -1, $cookiePath, $cookieDomain, false, false);
    }

    public static function getCookieDomain()
    {
		$localhostServerList = array('localhost', '127.0.0.1');

		$request = Request::getInstance();

		$httpHost = $request->getHttpHost();

		if(in_array($httpHost, $localhostServerList) || count(explode(".", $httpHost)) === 1)
		{
			$cookieDomain = null;
		}
		else
		{
			$hostChunks = explode(".", $request->getHttpHost());

			$hostChunks = array_slice($hostChunks, -2);

			$cookieDomain = "." . implode(".", $hostChunks);
		}

		return $cookieDomain;
    }

    public static function isSessionSet()
    {
		return SsoSession::getSessionId() !== null;
    }
}